<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  class tcbpay {
    public $code;
    public $title;
    public $description;
    public $enabled;

// class constructor
    function tcbpay() {
      global $order;

      $this->code = 'tcbpay';
      $this->title = MODULE_PAYMENT_TCBPAY_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_TCBPAY_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_TCBPAY_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_TCBPAY_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_TCBPAY_ORDER_STATUS_ID > 0) {
        $this->order_status = (int)MODULE_PAYMENT_TCBPAY_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_TCBPAY_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_TCBPAY_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }

// disable the module if the order only contains virtual products
      if ($this->enabled == true) {
        if ($order->content_type == 'virtual') {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      global $order;

      for ($i=1; $i<13; $i++) {
        $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
      }

      $today = getdate(); 
      for ($i=$today['year']; $i < $today['year']+10; $i++) {
        $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
      }

      $confirmation = array('fields' => array(
          array(
            'title' => MODULE_PAYMENT_TCBPAY_ENTRY_CARDHOLDER,
            'field' => tep_draw_input_field('cardholder', $order->billing['firstname'] . ' ' . $order->billing['lastname'])
          ),
          array(
            'title' => MODULE_PAYMENT_TCBPAY_ENTRY_CARDNUMBER,
            'field' => tep_draw_input_field('cardnumber', '', 'id="cardnumber"').tep_draw_hidden_field('enccardnum', '', 'id="enccardnum"')
          ),
          array(
            'title' => MODULE_PAYMENT_TCBPAY_ENTRY_CARDEXPIRY,
            'field' => tep_draw_pull_down_menu('expiry_month', $expires_month) . '&nbsp;' . tep_draw_pull_down_menu('expiry_year', $expires_year)
          )
        )
      );
      if (MODULE_PAYMENT_TCBPAY_USECVV == 'True') {
        $confirmation['fields'][] = array(
          'title' => MODULE_PAYMENT_TCBPAY_ENTRY_CVV,
          'field' => tep_draw_input_field('cardcvv', '', 'size="5" maxlength="4"')
        );
      }

      return $confirmation;
    }

    function process_button() {
      $api_js = 'https://gateway2.tcbpay.com/services/proxynization_api.js';
      if (MODULE_PAYMENT_TCBPAY_TESTMODE == 'True') {
        $api_js = 'https://gateway2-stg.tcbpay.com/services/proxynization_api.js';
      }
      $javascript = '<script type="text/javascript" src="'.$api_js.'"></script>';
      $javascript .= "<script>\n" .
      "$(document).ready(function() {\n" .
      "  $('form[name=\"checkout_confirmation\"] button[type=\"submit\"]').on('click', function(e) {\n" .
      "    $(this).prop('disabled', true);\n" .
      "    $('#tcbpay-cardform .error').remove();\n" .
      "    var emptyFields = $('[name=\"checkout_confirmation\"] input[type=\"text\"]').filter(function(index, elem) {\n" .
      "      return $(elem).attr('name').match(/^card/) && $.trim($(elem).val()) === '';\n" .
      "    });\n" .
      "    emptyFields.first().focus();\n" .
      "    if (emptyFields.length > 0) {\n" .
      "      $(this).prop('disabled', false);\n" .
      "    } else {\n" .
      "      TCBPayProxynizationAPI.process('#cardnumber', 'tcbpayClientCallback');\n" .
      "    }\n" .
      "    return false;\n" .
      "  });\n" .
      "});\n" .
      "function tcbpayClientCallback(respCode, respMsg, proxyCard) {\n" .
      "  if (respCode == \"A01\") {\n" .
      "    $('#enccardnum').val(proxyCard);\n" .
      "    $('#cardnumber').val('');\n" .
      "    $('form[name=\"checkout_confirmation\"]').submit();\n" .
      "  } else {\n" .
      "    $('[name=\"checkout_confirmation\"]').append('<div class=\"error text-danger text-center\">'+respMsg+'</div>');\n" .
      "  }\n" .
      "}\n" .
      "</script>\n";

      return $javascript;
    }

    function before_process() {
      global $HTTP_POST_VARS, $order, $tcbpay_transaction_id;

      if (!tep_session_is_registered('tcbpay_transaction_id')) tep_session_register('tcbpay_transaction_id');
      include(DIR_WS_CLASSES . 'tcbpay.php');
      $tcbpay = new Tcbpay_Api;
      $ccNumber = '';
      $encCardNum = trim($HTTP_POST_VARS['enccardnum']);
      $ccExpMonth = trim($HTTP_POST_VARS['expiry_month']);
      $ccExpYear = trim($HTTP_POST_VARS['expiry_year']);
      $cardCVV = '';
      if (MODULE_PAYMENT_TCBPAY_USECVV == 'True') {
        $cardCVV = trim($HTTP_POST_VARS['cardcvv']);
      }

      $error = '';
      if (!trim($HTTP_POST_VARS['cardholder'])) {
        $error = 'req_name';
      } elseif (!$encCardNum) {
        $error = 'req_cc';
      } elseif ($encCardNum) {
        $response = $tcbpay->decodeCard($encCardNum);
        $dcresp = $response['resp'];
        if ($response['success']) {
          $ccNumber = preg_replace('/[\-\s]+/', '', trim($dcresp->accountNumber));
        } elseif ($dcresp) {
          $error = $dcresp->description;
        } else {
          $error = 'TCBPay gateway error.';
        }
      } elseif (MODULE_PAYMENT_TCBPAY_USECVV == 'True' && !$cardCVV) {
        $error = 'req_cvv';
      }

      if (!$error) {
        $cc_validation = $tcbpay->card_validation();
        $cvld = $cc_validation->validate($ccNumber, $ccExpMonth, $ccExpYear);

        switch (true) {
          case $cvld === -1:
            $error = 'ccnc_'.substr($cc_validation->cc_number, 0, 4);
            break;
          case $cvld === -2:
          case $cvld === -3:
          case $cvld === -4:
            $error = 'expiry_invalid';
            break;
          case $cvld === -5:
          case $cvld === -6:
          case $cvld === -7:
            $error = 'cvv';
            break;
          case $cvld === -8:
            $error = 'notaccept';
            break;
          case $cvld === false:
            $error = 'ccinvalid';
            break;
        }

        $cctypes = explode(',', MODULE_PAYMENT_TCBPAY_CCTYPES);

        if (!in_array($cc_validation->cc_type, $cctypes)) {
          $error = 'notaccept';
        }
        if (MODULE_PAYMENT_TCBPAY_USECVV == 'True' && !preg_match($cc_validation->getCvvRegEx()[$cc_validation->cc_type], $cardCVV)) {
          $error = 'cvv';
        }

        if (!$error) {
          $zone_code = tep_get_zone_code($order->billing['country_id'], $order->billing['zone_id'], '');

          $post_data = array(
              "amount"            => round($order->info['total'], 2),
              "creditcard_number" => $encCardNum,                
              "expire_month"      => str_pad($ccExpMonth, 2, 0, STR_PAD_LEFT),
              "expire_year"       => $ccExpYear,
              "cvv"               => $cardCVV,
              "first_name"        => $order->billing['firstname'],
              "last_name"         => $order->billing['lastname'],
              "address"           => $order->billing['street_address'],
              "city"              => $order->billing['city'],
              "state"             => $zone_code,
              "zip_code"          => $order->billing['postcode'],
              "country_code"      => $order->billing['country']['iso_code_2'],
              "phone_number"      => $order->customer['telephone'],
              "email"             => $order->customer['email_address'],
              "currency"          => $order->info['currency'],
              "memo"              => $order->info['comments']
          );

          $response = $tcbpay->sendRequest($post_data);
          $resp = $response['resp'];

          if ($response['success']) {
            $tcbpay_transaction_id = $resp->transaction_id;
          } elseif ($resp) {
            $error = $resp->description;
          } else {
            $error = 'TCBPay gateway error.';
          }
        }
      }

      if ( $error ) {
        $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error);

        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }
    }

    function after_process() {
      tep_session_unregister('tcbpay_transaction_id');
    }

    function get_error() {
      global $HTTP_GET_VARS;

      $error_message = MODULE_PAYMENT_TCBPAY_ERR_GENERAL;

      switch ($HTTP_GET_VARS['error']) {
        case 'ccinvalid':
          $error_message = MODULE_PAYMENT_TCBPAY_ERR_CCINVALID;
          break;
        case 'expiry_invalid':
          $error_message = MODULE_PAYMENT_TCBPAY_ERR_EXPIRY;
          break;
        case 'notaccept':
          $error_message = MODULE_PAYMENT_TCBPAY_ERR_CCNOTACCEPT;
          break;
        case 'cvv':
          $error_message = MODULE_PAYMENT_TCBPAY_ERR_CVV;
          break;
        case 'req_name':
          $error_message = MODULE_PAYMENT_TCBPAY_ERR_RCARDHOLDER;
          break;
        case 'req_cc':
          $error_message = MODULE_PAYMENT_TCBPAY_ERR_RCARDNUMBER;
          break;
        case 'req_cvv':
          $error_message = MODULE_PAYMENT_TCBPAY_ERR_RCARDCVV;
          break;
        default:
          if (preg_match('/^ccnc_[0-9]{4}$/', trim($HTTP_GET_VARS['error']))) {
            $fourdigit = substr(strchr(trim($HTTP_GET_VARS['error']), '_'),1);
            $error_message = sprintf(MODULE_PAYMENT_TCBPAY_ERR_CCACCEPT, $fourdigit);
          } else {
            $error_message = $HTTP_GET_VARS['error'];
          }
          break;
      }

      $error = array('title' => MODULE_PAYMENT_TCBPAY_ERROR_TITLE,
                     'error' => $error_message);

      return $error;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_TCBPAY_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable TCB Pay Module', 'MODULE_PAYMENT_TCBPAY_STATUS', 'True', 'Do you want to accept TCB Pay payments?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Username', 'MODULE_PAYMENT_TCBPAY_USERNAME', '', 'TCB Pay merchant username', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Api Key', 'MODULE_PAYMENT_TCBPAY_PASSWORD', '', 'TCB Pay merchant api key', '6', '3', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Secret Key', 'MODULE_PAYMENT_TCBPAY_SECRETKEY', '', 'TCB Pay merchant secret key', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Credit Card Types', 'MODULE_PAYMENT_TCBPAY_CCTYPES', 'AE,VI,MC,DI,JCB', 'Enable this payment method for card types.', '6', '5', 'tep_cfg_pull_down_tcbpay_cctypes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable CVV', 'MODULE_PAYMENT_TCBPAY_USECVV', 'True', 'Do you want to enable CVV field to customers?', '6', '6', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Test Mode', 'MODULE_PAYMENT_TCBPAY_TESTMODE', 'True', 'Is TCB Pay test mode?', '6', '7', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_TCBPAY_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '8', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_TCBPAY_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '9', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_TCBPAY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '10', now())");
      
   }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_TCBPAY_STATUS', 'MODULE_PAYMENT_TCBPAY_USERNAME', 'MODULE_PAYMENT_TCBPAY_PASSWORD', 'MODULE_PAYMENT_TCBPAY_SECRETKEY', 'MODULE_PAYMENT_TCBPAY_CCTYPES', 'MODULE_PAYMENT_TCBPAY_USECVV', 'MODULE_PAYMENT_TCBPAY_TESTMODE', 'MODULE_PAYMENT_TCBPAY_ZONE', 'MODULE_PAYMENT_TCBPAY_ORDER_STATUS_ID', 'MODULE_PAYMENT_TCBPAY_SORT_ORDER');
    }
  }
?>
